import * as fs from "fs";
import * as path from "path";

export default class FilePath {
  constructor(public readonly path: string) {}

  toString() {
    return this.path;
  }

  get name() {
    return path.basename(this.path);
  }

  get parent() {
    return new FilePath(path.dirname(this.path));
  }

  get ext() {
    return path.extname(this.path);
  }

  exists() {
    return fs.existsSync(this.path);
  }

  readText(): string {
    return fs.readFileSync(this.path, "utf-8");
  }

  // writeText(content: string) {
  //   fs.writeFileSync(this.path, content, "utf-8");
  // }

  join(...segments: string[]) {
    return new FilePath(path.join(this.path, ...segments));
  }
}
